<template>
  <div class="lefttop-toolbox-panel">
    <div>
      <div class="init-choose" @click="changeSelect()">
        <img src="@/assets/images/map-pages/icon/toolbox/circle.png" alt=""/>
      </div>
      <el-menu class="el-menu"
               mode="horizontal"
               :collapse="isCollapse"
               unique-opened
               @select="handleSelect"
               v-show='selectGroup'
      >
        <base-nav-menu-item :menuList='menuList'></base-nav-menu-item>
      </el-menu>
    </div>
    <!--文字标注弹框-->
    <!--    <TextBounced v-show="this.bouncedText" @changeBounced="gitBounced"></TextBounced>-->
  </div>
</template>

<script>
// import legend from '@/assets/images/map-pages/icon/toolbox/legend.png'
// import square from '@/assets/images/map-pages/icon/toolbox/square.png'
import circle from '@assets/images/map-pages/icon/toolbox/circle.png'
import location from '@assets/images/map-pages/icon/toolbox/location.png'
import polygon from '@assets/images/map-pages/icon/toolbox/polygon.png'
import fullscreen from '@assets/images/map-pages/icon/toolbox/fullscreen.png'

// 测量的方法
import '@/components/plugin/leaflet-measure-path/leaflet-measure-path.css'
import Measure from '@/components/plugin/MeaSure'

// 标注的方法
import MakeTation from '@components/plugin/MakeTation'

// 封装的选择弹框
import BaseNavMenuItem from '@components/panel/BaseNavMenuItem'

export default {
  name: 'ToolBoxPanel',
  components: { BaseNavMenuItem },
  data () {
    return {
      menuList: [
        {
          icon: circle,
          label: '标绘',
          index: '1',
          items: [
            {
              index: '1-1',
              label: '点标绘'
            },
            {
              index: '1-2',
              label: '线标绘'
            },
            {
              index: '1-3',
              label: '面标绘',
              items: [
                {
                  index: '1-3-1',
                  label: '圆形'
                },
                {
                  index: '1-3-2',
                  label: '多边形'
                },
                {
                  index: '1-3-3',
                  label: '矩形'
                }
              ]
            }
          ]
        },
        {
          icon: location,
          label: '切换底图',
          index: '2',
          items: [
            {
              label: '影像图',
              index: '2-1',
              items: [
                {
                  index: '2-1-1',
                  label: '影像標注'
                }
              ]
            },
            {
              label: '矢量图',
              index: '2-2',
              items: [
                {
                  index: '2-2-1',
                  label: '矢量標注'
                }
              ]
            },
            {
              label: '地形图',
              index: '2-3',
              items: [
                {
                  index: '2-3-1',
                  label: '地形標注'
                }
              ]
            }
          ]
        },
        {
          icon: polygon,
          label: '管网',
          index: '3',
          items: [
            {
              index: '3-1',
              label: '连通性分析'
            },
            {
              index: '3-2',
              label: '爆管分析'
            },
            {
              index: '3-3',
              label: '流向分析'
            },
            {
              index: '3-4',
              label: '横断面分析'
            }
          ]
        },
        {
          icon: fullscreen,
          label: '下载',
          index: '4',
          items: [
            {
              index: '4-1',
              label: '全屏'
            },
            {
              index: '4-2',
              label: 'A4横向'
            },
            {
              index: '4-3',
              label: 'A4纵向'
            }
          ]
        }
      ],
      isCollapse: false,
      selectGroup: false,
      drawLayer: null,
      map: null,
      L: window.L,
      // 控制工具栏 文字标注 的弹框是否显示
      bouncedText: false
    }
  },
  methods: {
    handleOpen () {
    },
    handleClose () {
    },
    handleSelect (index) {
      console.log(index)
      switch (index) {
        case '4-1':
          // this.map.toggleFullscreen()
          var printer = this.L.easyPrint({
            sizeModes: ['Current', 'A4Landscape', 'A4Portrait'],
            filename: 'map_image',
            exportOnly: true,
            hideControlContainer: true
          }).addTo(this.map)
          printer.printMap('CurrentSize', 'MyManualPrint')
          break
        case 'A4横向':
          var printerX = this.L.easyPrint({
            sizeModes: ['Current', 'A4Landscape', 'A4Portrait'],
            filename: 'map_image',
            exportOnly: true,
            hideControlContainer: true
          }).addTo(this.map)
          printerX.printMap('A4Landscape page', 'MyManualPrint')
          break
        case 'A4纵向':
          var printerY = this.L.easyPrint({
            sizeModes: ['Current', 'A4Landscape', 'A4Portrait'],
            filename: 'map_image',
            exportOnly: true,
            hideControlContainer: true
          }).addTo(this.map)
          printerY.printMap('A4Portrait page', 'MyManualPrint')
          break
        case '线标绘':
          this.drawLayer = this.map.editTools.startPolyline()
          this.drawLayer.on('dblclick').on('dblclick', this.drawLayer.toggleEdit)
          Measure.startMeasureLen(this.map, this.L)
          break
        case '面标绘':
          this.drawLayer = this.map.editTools.startPolygon()
          this.drawLayer.on('dblclick').on('dblclick', this.drawLayer.toggleEdit)
          break
        case '多边形':
          alert('多边形')
          break
        case '点标绘':
          MakeTation.StartPointAnnotation(this.map, this.L)
          break
        case '图标标注':
          this.drawLayer = this.map.editTools.startIcon()
          this.drawLayer.on('dblclick').on('dblclick', this.drawLayer.toggleEdit)
          break
        case '文字标注':
          this.bouncedText = true
          MakeTation.startMakeText(this.map, this.L)
          break
        case '距离测量':
          Measure.startMeasureLen(this.map, this.L)
          break
        case '面积测量':
          Measure.startMeasureArea(this.map, this.L)
          break
      }
    },
    gitBounced (params) {
      this.bouncedText = params
    },
    changeSelect () {
      this.selectGroup = !this.selectGroup
    }
  }
}
</script>

<style lang="less">
.lefttop-toolbox-panel {
  position: absolute;
  left: 15px;
  top: 15px;
  z-index: 999;

  div {
    width: 100%;
    height: 55px;
    line-height: 55px;
    display: flex;
    align-items: center;

    .init-choose {
      background: #305B62;
      width: 35px;
      height: 35px;
      border-radius: 50%;
      border: 2px skyblue solid;
      display: flex;
      align-items: center;
      justify-content: center;
      z-index: 999;
    }

    .el-menu {
      width: 100%;
      background: none;
      z-index: 1;
      border: none;
      background: #305B62;
      border-radius: 50px;
      //margin-left: -30px;

      .el-icon-arrow-down:before {
        content: " ";
      }

      .el-submenu__title:focus, .el-submenu__title:hover {
        background: none;
      }
    }
  }

  //.transition {
  //  @keyframes bounce-in {
  //    0% {
  //      transform: scale(0);
  //      opacity: 0.3;
  //    }
  //    100% {
  //      transform: scale(1);
  //      opacity: 1;
  //    }
  //  }
  //
  //  .fade-enter-active {
  //    transform-origin: left center;
  //    animation: bounce-in .2s;
  //  }
  //
  //  .fade-leave-active {
  //    transform-origin: left;
  //    animation: bounce-in .2s reverse;
  //  }
  //}

}
.el-menu--horizontal {
  .el-menu--popup {
    min-width: 100px;
    .el-menu-item {
      min-width: 50px;
    }
  }
}
ul {
  padding-inline-start: 0;
}
</style>
